<template>
  <div>
    <h1>{{ title }}</h1>
    <p>{{ fullName }}</p>
    <button @click="updateLastName">Mettre à jour le nom de famille</button>

    <br />
    <br />
    <router-link to="/component-exercise">On fonce vers l'exercice</router-link> |
  </div>
</template>

<script>
export default {
  name: 'FullExample', // useful for debugging purposes

  data: function () {
    return {
      title: 'Je suis le composant d\'exemple !',
      firstName: 'Thomas',
      lastName: 'Laigneau',
    }
  }, // component internal state variables

  computed: {
    fullName () {
      return this.firstName + ' ' + this.lastName;
    }
  }, // computed properties

  watch: {
    firstName: function (newValue, oldValue) {
      alert('Changement de la valeur pour firstName : ' + oldValue + ' => ' + newValue);
    }
  }, // observed properties

  methods: {
    updateLastName () {
      return this.lastName = 'Le champion';
    }
  }, // component own methods

  // component lifecycle hooks
  beforeCreate() {
    alert('beforeCreate');
  },

  created() {
    alert('created');
    // this.firstName = 'Toto';
  },

  beforeMount() {
    alert('beforeMount');
  },

  mounted() {
    alert('mounted');
  },

  beforeUpdate() {
    alert('beforeUpdate');
  },

  updated() {
    alert('updated');
  },

  beforeDestroy() {
    alert('beforeDestroy');
  },

  destroyed() {
    alert('destroyed');
  }
};
</script>
